# snap plugin collector pciessd

1. [Contributing Code](#contributing-code)
2. [Contributing Examples](#contributing-examples)
3. [Contribute Elsewhere](#contribute-elsewhere)
4. [Reporting Security Issues](#reporting-security-issues)
5. [Thank You](#thank-you)

This repository is primarily **community supported**. We both appreciate and need your contribution to keep it stable. Thank you for being part of the community! We love you for it.

## Contributing Code
**_IMPORTANT_**: We encourage contributions to the project from the community. We ask that you keep the following guidelines in mind when planning your contribution.

* Whether your contribution is for a bug fix or a feature request, **create an [Issue](https://github.com/intelsdi-x/snap-plugin-collector-pciessd/issues)** and let us know what you are thinking.
* **For bugs**, if you have already found a fix, feel free to submit a Pull Request referencing the Issue you created. Include the `Fixes #` syntax to link it to the issue you're addressing.
* **For feature requests**, we want to improve upon the library incrementally which means small changes at a time. In order to ensure your PR can be reviewed in a timely manner, please keep PRs small, e.g. <10 files and <500 lines changed. If you think this is unrealistic, then mention that within the issue and we can discuss it.

Once you're ready to contribute code back to this repo, start with these steps:

* Fork the appropriate sub-projects that are affected by your change.
* Clone the fork to `$GOPATH/src/github.com/intelsdi-x/`:
  ```
  $ cd "${GOPATH}/src/github.com/intelsdi-x/"
  $ git clone https://github.com/intelsdi-x/snap-plugin-collector-pciessd.git
  ```
* Create a topic branch for your change and checkout that branch:
  ```
  $ git checkout -b some-topic-branch
  ```
* Make your changes to the code and add tests to cover contributed code.
* Validate the changes and run the test suite if one is provided.
* Commit your changes and push them to your fork.
* Open a pull request for the appropriate project.
* Contributors will review your pull request, suggest changes, and merge it when it’s ready and/or offer feedback.

If you have questions feel free to contact the [maintainers](https://github.com/intelsdi-x/snap/blob/master/docs/MAINTAINERS.md).

## Contributing Examples
The most immediately helpful way you can benefit this project is by cloning the repository, adding some further examples and submitting a pull request.

Have you written a blog post about how you use [Snap](http://github.com/intelsdi-x/snap) and/or this plugin? Send it to us [on Slack](http://slack.snap-telemetry.io)!

## Contribute Elsewhere
This repository is one of **many** plugins in **Snap**, a powerful telemetry framework. See the full project at http://snap-telemetry.io


## Reporting Security Issues

The Snap team take security very seriously. If you have any issue regarding security,
please notify us by sending an email to snap-security@intel.com and not by creating a GitHub issue.
We will follow up with you promptly with more information and a plan for remediation.
While we are not offering a security bounty, we would love to send some Snap swag your way along with our
deepest gratitude for your assistance in making Snap a more secure product.

## Thank You
And **thank you!** Your contribution, through code and participation, is incredibly important to us.
